{*
*   TvConst.pas
*
*   Declare Turbo Vision command constants.
*
*   Copyright 1992 by Richard W. Hansen
*
*}

UNIT TvConst;

{$I TVDEFS.INC}

INTERFACE


{ TvMenus.pas }

CONST
  cmMarkStart     = 10000;           { Start of marked menu items            }
  cmMarkEnd       = 11000;           { End of marked menu items
                                      Start and End are used by HandleEvent
                                      to toggle menu markers.               }


{ TvViews.pas }

CONST
  cmCursorMoved   = 11001;
  cmUpdateView    = 11002;
  cmEditView      = 11003;


  cmScrollUp      = 11010;
  cmScrollDown    = 11011;
  cmPrint         = 11012;
  cmDisplayStr    = 11020;
  cmDisplayClr    = 11021;


{ TvScroll.pas }

{$IFDEF TVSCROLL}
CONST
  gfGrowXYRel     = $80;
  cmDragView      = 11050;
{$ENDIF}


{ TvDialog.pas }

CONST
  cmStartJob      = 251;
  cmPauseJob      = 252;
  cmContinueJob   = 253;
  cmCancelJob     = 254;
  cmJobComplete   = 255;
  cmListItemFocused = 11060;


{ TvInput.pas }

CONST
  cmFieldError    = 12000;
  cmIdentify      = 12001;
  cmLoseFocus     = 12002;

  efRequired      = $0001;  { Field entry is required       }
  efRJustify      = $0002;  { Trim and Right justify result }
  efLJustify      = $0004;  { Trim and Left justify result  }
  efTrim          = $0008;  { Trim al pad chars result      }
  efHide          = $0010;  { Password input                }



CONST
  ErrorMsg        : String[80] = '';

IMPLEMENTATION
END.