{*
*
*   Copyright (c) 1992 by Richard W. Hansen
*
*   This source code will compile.
*   Unpacked source is available to registered users.
*
*}
UNIT TvString;{$V-}INTERFACE USES TvConst,TvType;CONST HexDigits:Array[0..$F]of Char='0123456789ABCDEF';
Procedure Pad(var S:String;Len:Byte);Procedure LeftPad(var S:String;Len:Byte);Procedure PadCh(var S:String;Len:Byte;Ch:Char);
Procedure LeftPadCh(var S:String;Len:Byte;Ch:Char);Procedure Trim(var S:String);Procedure TrimCh(var S:String;Ch:Char);
Procedure CopyInto(InStr:String;Column:Byte;var OutStr:String);Procedure Strip(var S:String;Chars:TCharSet);
Function Blanks(Len:Byte):String;Procedure StrTruncate(var S:String;Len:Byte);Function Chars(Len:Byte;Ch:Char):String;
Function AllBlanks(var S:String):Boolean;Function HexString(I:LongInt):String;{$IFOPT N+}Function FormatF(Mask:String;
Flt:Double;DP:Integer):String;{$ELSE}Function FormatF(Mask:String;Flt:Real;DP:Integer):String;{$ENDIF}
Function FormatI(Mask:String;Long:LongInt):String;IMPLEMENTATION Procedure Pad(var S:String;Len:Byte);var
SLen:Byte Absolute S;begin if(SLen<Len)then begin FillChar(S[SLen+1],Len-SLen,' ');SLen:=Len;end;end;
Procedure LeftPad(var S:String;Len:Byte);var SLen:Byte Absolute S;X:Byte;begin if(SLen<Len)then begin X:=Len-SLen;
Move(S[1],S[X+1],SLen);FillChar(S[1],X,' ');SLen:=Len;end;end;Procedure PadCh(var S:String;Len:Byte;Ch:Char);var
SLen:Byte Absolute S;begin if(SLen<Len)then begin FillChar(S[SLen+1],Len-SLen,Ch);SLen:=Len;end;end;
Procedure LeftPadCh(var S:String;Len:Byte;Ch:Char);var SLen:Byte Absolute S;X:Byte;begin if(SLen<Len)then begin X:=Len-SLen;
Move(S[1],S[X+1],SLen);FillChar(S[1],X,Ch);SLen:=Len;end;end;Procedure Trim(var S:String);var i:Word;SLen:Byte absolute S;
begin while(SLen>0)and(S[SLen]=' ')do Dec(SLen);i:=1;while(i<=SLen)and(S[I]=' ')do Inc(i);if(i>1)then begin SLen:=SLen-i+1;
Move(S[i],S[1],SLen);end;end;Procedure Trimch(var S:String;Ch:Char);var i:Word;SLen:Byte absolute S;begin
while(SLen>0)and(S[SLen]=Ch)do Dec(SLen);i:=1;while(i<=SLen)and(S[I]=Ch)do Inc(i);if(i>1)then begin SLen:=SLen-i+1;
Move(S[i],S[1],SLen);end;end;Function Blanks(Len:Byte):String;var S:String;SLen:Byte Absolute S;begin FillChar(S[1],Len,' ');
SLen:=Len;Blanks:=S;end;Function Chars(Len:Byte;Ch:Char):String;var S:String;SLen:Byte Absolute S;begin FillChar(S[1],Len,Ch);
SLen:=Len;Chars:=S;end;Procedure CopyInto(InStr:String;Column:Byte;var OutStr:String);var OutLen:Byte Absolute OutStr;
InLen:Byte Absolute InStr;begin if(InLen<>0)then begin if(Column>OutLen)then EXIT else if(Column+InLen-1>OutLen)then
Move(InStr[1],OutStr[Column],OutLen-Column+1)else Move(InStr[1],OutStr[Column],InLen);end;end;Procedure Strip(var S:String;
Chars:TCharSet);var SLen:Byte Absolute S;i,j:Byte;begin j:=0;for i:=1 to SLen do if not(S[i]in Chars)then begin Inc(j);
S[j]:=S[i];end;Byte(S[0]):=j;end;Function AllBlanks(var S:String):Boolean;var i:Byte;Len:Byte Absolute S;begin i:=Len;
While(i>0)and(S[i]=' ')do Dec(i);AllBlanks:=(i=0);end;Procedure StrTruncate(var S:String;Len:Byte);var SLen:Byte Absolute S;
begin if(SLen>Len)then SLen:=Len;end;Function HexString(I:LongInt):String;var S:String;begin With THexLong(I)do begin
S[0]:=#9;S[1]:='$';S[2]:=HexDigits[Hi(High)shr$4];S[3]:=HexDigits[Hi(High)and$F];S[4]:=HexDigits[Lo(High)shr$4];
S[5]:=HexDigits[Lo(High)and$F];S[6]:=HexDigits[Hi(Low)shr$4];S[7]:=HexDigits[Hi(Low)and$F];S[8]:=HexDigits[Lo(Low)shr$4];
S[9]:=HexDigits[Lo(Low)and$F];end;HexString:=S;end;{$IFOPT N+}Function FormatF(Mask:String;Flt:Double;DP:Integer):String;
{$ELSE}Function FormatF(Mask:String;Flt:Real;DP:Integer):String;{$ENDIF}var RDigits:Byte;LDigits:Byte;DPos:Byte;Width:Byte;
i:Integer;j:Integer;Left:Boolean;Num:String[30];Temp:String[30];begin if(Byte(Mask[0])>30)then Byte(Mask[0]):=30;Temp:=Mask;
Left:=True;RDigits:=0;LDigits:=0;DPos:=0;for i:=1 to Length(Mask)do begin Case Mask[i]of '@','#','&':begin if Left then
Inc(LDigits)else Inc(RDigits);end;'.':begin Left:=False;DPos:=i;end;end;end;if(DP<0)or(DP>RDigits)then DP:=RDigits;
Width:=LDigits+DP;if(DP>0)then Inc(Width);Str(Flt:Width:DP,Num);j:=DPos-1;i:=Length(Num)-DP;if(DP<>0)then Dec(i);
While(i>0)and(j>0)do begin Case Temp[j]of '@','#','&':begin if(Num[i]=' ')then begin i:=0;end else begin Temp[j]:=Num[i];
Dec(i);end;end;end;Dec(j);end;if(i=0)then begin j:=DPos+1;i:=Length(Num)-DP+1;While(i<=Length(Num))and(j<=Length(Temp))do
begin Case Temp[j]of '@','#','&':begin Temp[j]:=Num[i];Inc(i);end;end;Inc(j);end;j:=0;Num:='';for i:=1 to Length(Temp)do
Case Temp[i]of '#':begin Inc(j);Num[j]:=' ';end;'@':begin Inc(j);Num[j]:='0';end;',':begin if(i>1)and(i<Length(Temp))then
begin if((Temp[i-1]='#')or(Temp[i+1]='#'))then begin Inc(j);Num[j]:=' 'end else if(Temp[i-1]<>'&')and(Temp[i+1]<>'&')then
begin Inc(j);Num[j]:=Temp[i];end;end else if(i<Length(Temp))and(Temp[i+1]<>'&')then begin Inc(j);Num[j]:=' 'end 
else if(i>1)and(Temp[i-1]<>'&')then begin Inc(j);Num[j]:=' 'end;end;'&':begin end;else begin Inc(j);Num[j]:=Temp[i];end;end;
Byte(Num[0]):=j;end else begin Num:='';for i:=1 to Length(Mask)do Case Mask[i]of '@','#','&':Num[i]:='*';else Num[i]:=Mask[i];
end;Byte(Num[0]):=Length(Mask);end;FormatF:=Num;end;Function FormatI(Mask:String;Long:LongInt):String;var Width:Byte;
i:Integer;j:Integer;Num:String[30];Temp:String[30];begin Temp:=Mask;Width:=0;for i:=1 to Length(Mask)do begin Case Mask[i]of
'@','#','&':begin Inc(Width)end;end;end;Str(Long:Width,Num);i:=Length(Num);j:=Length(Temp);While(i>0)and(j>0)do begin
Case Temp[j]of '@','#','&':begin if(Num[i]=' ')then begin i:=0;end else begin Temp[j]:=Num[i];Dec(i);end;end;end;Dec(j);end;
if(i=0)then begin j:=0;Num:='';for i:=1 to Length(Temp)do Case Temp[i]of '#':begin Inc(j);Num[j]:=' ';end;'@':begin Inc(j);
Num[j]:='0';end;',':begin if(i>1)and(i<Length(Temp))then begin if((Temp[i-1]='#')or(Temp[i+1]='#'))then begin Inc(j);
Num[j]:=' 'end else if(Temp[i-1]<>'&')and(Temp[i+1]<>'&')then begin Inc(j);Num[j]:=Temp[i];end;end 
else if(i<Length(Temp))and(Temp[i+1]<>'&')then begin Inc(j);Num[j]:=' 'end else if(i>1)and(Temp[i-1]<>'&')then begin Inc(j);
Num[j]:=' 'end;end;'&':begin end;else begin Inc(j);Num[j]:=Temp[i];end;end;Byte(Num[0]):=j;end else begin Num:='';
for i:=1 to Length(Mask)do Case Mask[i]of '@','#','&':Num[i]:='*';else Num[i]:=Mask[i];end;Byte(Num[0]):=Length(Mask);end;
FormatI:=Num;end;END.
